Option Strict On

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Public Class frmEnumeration
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents cmbResolution As System.Windows.Forms.ComboBox
  Friend WithEvents chkWindowed As System.Windows.Forms.CheckBox
  Friend WithEvents cmdStart As System.Windows.Forms.Button
  Friend WithEvents cmdClose As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.cmbResolution = New System.Windows.Forms.ComboBox()
Me.chkWindowed = New System.Windows.Forms.CheckBox()
Me.cmdStart = New System.Windows.Forms.Button()
Me.cmdClose = New System.Windows.Forms.Button()
Me.SuspendLayout()
'
'cmbResolution
'
Me.cmbResolution.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
Me.cmbResolution.Enabled = False
Me.cmbResolution.Location = New System.Drawing.Point(184, 8)
Me.cmbResolution.Name = "cmbResolution"
Me.cmbResolution.Size = New System.Drawing.Size(248, 21)
Me.cmbResolution.TabIndex = 1
'
'chkWindowed
'
Me.chkWindowed.Checked = True
Me.chkWindowed.CheckState = System.Windows.Forms.CheckState.Checked
Me.chkWindowed.Location = New System.Drawing.Point(8, 8)
Me.chkWindowed.Name = "chkWindowed"
Me.chkWindowed.Size = New System.Drawing.Size(168, 24)
Me.chkWindowed.TabIndex = 2
Me.chkWindowed.Text = "In ein Fenster rendern"
'
'cmdStart
'
Me.cmdStart.Location = New System.Drawing.Point(272, 40)
Me.cmdStart.Name = "cmdStart"
Me.cmdStart.Size = New System.Drawing.Size(160, 24)
Me.cmdStart.TabIndex = 3
Me.cmdStart.Text = "Los gehts!"
'
'cmdClose
'
Me.cmdClose.Location = New System.Drawing.Point(8, 40)
Me.cmdClose.Name = "cmdClose"
Me.cmdClose.Size = New System.Drawing.Size(160, 24)
Me.cmdClose.TabIndex = 4
Me.cmdClose.Text = "Schlieen"
'
'frmEnumeration
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.ClientSize = New System.Drawing.Size(440, 72)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.cmdClose, Me.cmdStart, Me.chkWindowed, Me.cmbResolution})
Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
Me.MaximizeBox = False
Me.MinimizeBox = False
Me.Name = "frmEnumeration"
Me.Text = "DirectX: Enumeration"
Me.ResumeLayout(False)

    End Sub

#End Region

  Public DevWidth As Integer
  Public DevHeight As Integer
  Public DevDepth As Integer
  Public Cancel As Boolean

  Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    GetResolutions()
  End Sub

  Private Sub GetResolutions()
    Try
      Dim dispmode As DisplayMode
      Dim adapterinfo As AdapterInformation = Manager.Adapters(0)

      For Each dispmode In adapterinfo.SupportedDisplayModes
        If dispmode.Format = Format.R5G6B5 And dispmode.RefreshRate = 60 Then
          cmbResolution.Items.Add(dispmode.Width & " x " & dispmode.Height & " x " & 16)
        ElseIf dispmode.Format = Format.X8R8G8B8 And dispmode.RefreshRate = 60 Then
          cmbResolution.Items.Add(dispmode.Width & " x " & dispmode.Height & " x " & 32)
        End If
        If dispmode.Equals(adapterinfo.CurrentDisplayMode) Then cmbResolution.SelectedIndex = cmbResolution.Items.Count - 1
      Next
    Catch err As Direct3DXException
    Catch
    End Try
  End Sub

  Private Sub chkWindowed_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkWindowed.CheckedChanged
    cmbResolution.Enabled = Not chkWindowed.Checked
    cmbResolution_SelectedIndexChanged(Nothing, Nothing)
  End Sub

  Private Sub cmdStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStart.Click
    Me.Close()
  End Sub

  Private Sub cmbResolution_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmbResolution.SelectedIndexChanged
    If chkWindowed.Checked Then
      DevWidth = 0 : DevHeight = 0 : DevDepth = 0
    Else
      Dim str() As String = cmbResolution.Items(cmbResolution.SelectedIndex).ToString.Split("x"c)
      DevWidth = CInt(str(0).Trim)
      DevHeight = CInt(str(1).Trim)
      DevDepth = CInt(str(2).Trim)
    End If
  End Sub

  Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
    Cancel = True
    Me.Close()
  End Sub
End Class
